VERSION 5.00
Begin VB.UserControl ButBox 
   BackColor       =   &H00E0E0E0&
   ClientHeight    =   1080
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   ScaleHeight     =   1080
   ScaleWidth      =   4800
   ToolboxBitmap   =   "ButBox.ctx":0000
   Begin VB.Timer MoveTim 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   4200
      Top             =   480
   End
   Begin VB.Label Chk_Label 
      Alignment       =   2  'Center
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "XXXXXXXXXXXX"
      ForeColor       =   &H003B3B3B&
      Height          =   195
      Left            =   240
      TabIndex        =   0
      Top             =   240
      Width           =   1260
   End
   Begin VB.Line lnr 
      BorderColor     =   &H00222E28&
      X1              =   1680
      X2              =   1680
      Y1              =   120
      Y2              =   840
   End
   Begin VB.Line lnu 
      BorderColor     =   &H00809188&
      X1              =   1200
      X2              =   120
      Y1              =   120
      Y2              =   120
   End
   Begin VB.Line lnd 
      BorderColor     =   &H00222E28&
      X1              =   600
      X2              =   1680
      Y1              =   840
      Y2              =   840
   End
   Begin VB.Line lnl 
      BorderColor     =   &H00809188&
      X1              =   120
      X2              =   120
      Y1              =   120
      Y2              =   840
   End
   Begin VB.Image ButPic 
      Height          =   240
      Left            =   240
      Top             =   480
      Width           =   240
   End
End
Attribute VB_Name = "ButBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Option Explicit

' ---------------------------------------
'-                                       -
'-************************************   -
'- Button User Control v: 1.0 beta       -
'-************************************   -
'- Created by -=VERITAS=-                -
'- (c) 2004-2005                         -
'- All rights reserved                   -
'-                                       -
' ---------------------------------------

Private Declare Function WindowFromPoint Lib "user32" (ByVal xPoint As Long, ByVal yPoint As Long) As Long
Private Declare Function GetCursorPos Lib "user32" (lpPoint As POINTAPI) As Long

Private Type POINTAPI
        X As Long
        Y As Long
End Type

Public Enum constPos
    Leftx = 0
    Centerx = 1
    Rightx = 2
End Enum

Dim sCol1 As OLE_COLOR
Dim sCol2 As OLE_COLOR
Dim VarClc As Integer
Dim mousePt As POINTAPI

Event Resize()
Event Click()
Event KeyPress(KeyAscii As Integer)
Event MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Event MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)

Const m_def_CaptionPosition = "1"
Const m_def_PicturePosition = "0"
Dim m_CaptionPosition As String
Dim m_PicturePosition As String
Dim mPictureBut As Picture
Dim senabledCon As Boolean

Public Property Get ForeColor() As OLE_COLOR
    ForeColor = Chk_Label.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
    Chk_Label.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
End Property

Public Property Get Enabled() As Boolean
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
    UserControl.Enabled() = New_Enabled
    
    PropertyChanged "Enabled"
End Property


Public Property Get Font() As Font
    Set Font = Chk_Label.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
    Set Chk_Label.Font = New_Font
    PropertyChanged "Font"
End Property


Private Sub Chk_Label_Click()
RaiseEvent Click
End Sub
Private Sub Chk_Label_DblClick()
RaiseEvent Click
    Call sButClick
End Sub
Private Sub Chk_Label_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
    Call sButClick
End Sub
Private Sub Chk_Label_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    Call sUnClick
End Sub


Private Sub ButPic_Click()
RaiseEvent Click
End Sub
Private Sub ButPic_DblClick()
RaiseEvent Click

    Call sButClick
End Sub
Private Sub ButPic_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
    Call sButClick
End Sub
Private Sub ButPic_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    Call sUnClick
End Sub


Private Sub UserControl_Click()
RaiseEvent Click
End Sub
Private Sub UserControl_DblClick()
RaiseEvent Click
    Call sButClick
End Sub
Private Sub UserControl_KeyPress(KeyAscii As Integer)
    RaiseEvent KeyPress(KeyAscii)
    PropertyChanged "Caption"
End Sub
Private Sub UserControl_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseDown(Button, Shift, X, Y)
    Call sButClick
End Sub
Private Sub UserControl_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseUp(Button, Shift, X, Y)
    Call sUnClick
End Sub
Private Sub UserControl_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    RaiseEvent MouseMove(Button, Shift, X, Y)
End Sub

Private Sub MoveTim_Timer()
If Enabled = False Then MoveTim.Enabled = False: Exit Sub

GetCursorPos mousePt
If WindowFromPoint(mousePt.X, mousePt.Y) = UserControl.hWnd Then
Else
    Call sUnClick
End If
End Sub

Public Property Get Caption() As String
    Caption = Chk_Label.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
    Chk_Label.Caption() = New_Caption
    PropertyChanged "Caption"
    
    CapPos m_CaptionPosition
End Property

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

    Chk_Label.ForeColor = PropBag.ReadProperty("ForeColor", &HC0C0C0)
    UserControl.Enabled = PropBag.ReadProperty("Enabled", True)
    Set Chk_Label.Font = PropBag.ReadProperty("Font", Ambient.Font)
    Chk_Label.Caption = PropBag.ReadProperty("Caption", "")
    UserControl.BackColor = PropBag.ReadProperty("BackColor", &H8000000D)
       
    m_CaptionPosition = PropBag.ReadProperty("CaptionPosition", m_def_CaptionPosition)
    m_PicturePosition = PropBag.ReadProperty("PicturePosition", m_def_PicturePosition)
    
    Set mPictureBut = PropBag.ReadProperty("PictureBut", Nothing)

    senabledCon = PropBag.ReadProperty("BorderEnabled", True)
    
    ButPic.Picture = mPictureBut
    
    BorderCh senabledCon

End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)

    Call PropBag.WriteProperty("ForeColor", Chk_Label.ForeColor, &HC0C0C0)
    Call PropBag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call PropBag.WriteProperty("Font", Chk_Label.Font, Ambient.Font)
    Call PropBag.WriteProperty("Caption", Chk_Label.Caption, "")
    Call PropBag.WriteProperty("BackColor", UserControl.BackColor, &H8000000D)
    
    Call PropBag.WriteProperty("CaptionPosition", m_CaptionPosition, m_def_CaptionPosition)
    Call PropBag.WriteProperty("PicturePosition", m_PicturePosition, m_def_PicturePosition)
   
    Call PropBag.WriteProperty("BorderEnabled", senabledCon, "")
    
    Call PropBag.WriteProperty("PictureBut", mPictureBut, Nothing)

End Sub


Private Sub UserControl_Resize()
    RaiseEvent Resize
    lnl.X1 = 0
    lnl.X2 = 0
    lnl.Y1 = -100
    lnl.Y2 = UserControl.Height + 100
    
    lnu.X1 = -100
    lnu.X2 = UserControl.Width + 100
    lnu.Y1 = 0
    lnu.Y2 = 0
    
    lnr.X1 = UserControl.Width - 8
    lnr.X2 = UserControl.Width - 8
    lnr.Y1 = -100
    lnr.Y2 = UserControl.Height + 100
    
    lnd.X1 = -100
    lnd.X2 = UserControl.Width + 100
    lnd.Y1 = UserControl.Height - 8
    lnd.Y2 = UserControl.Height - 8
    
    CapPos m_CaptionPosition
    MoveTim.Enabled = True

End Sub

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
    Caption = Name
    Enabled = True
    m_CaptionPosition = m_def_CaptionPosition
    m_PicturePosition = m_def_PicturePosition
    MoveTim.Enabled = False
    
    senabledCon = True
    
    Set mPictureBut = Nothing
End Sub

Public Property Get BackColor() As OLE_COLOR
    BackColor = UserControl.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
    UserControl.BackColor() = New_BackColor
   ' Chk_Deffault.BackColor = New_BackColor
    PropertyChanged "BackColor"
End Property
Property Get CaptionPosition() As constPos
    CaptionPosition = m_CaptionPosition
End Property

Public Property Let CaptionPosition(New_Position As constPos)
    m_CaptionPosition = New_Position
    
    CapPos m_CaptionPosition
    
    PropertyChanged "CaptionPosition"
End Property

Function CapPos(ByVal m_CaptionPosition)

Select Case m_CaptionPosition
    Case 0:
        Chk_Label.Left = 140
    Case 1:
        Chk_Label.Left = (UserControl.Width \ 2) - (Chk_Label.Width \ 2)
    Case 2:
        Chk_Label.Left = UserControl.Width - Chk_Label.Width - 140
End Select

ButPos m_PicturePosition

Chk_Label.Top = (UserControl.Height \ 2) - (Chk_Label.Height \ 2)
    
End Function


Property Get PicturePosition() As constPos
    PicturePosition = m_PicturePosition
End Property

Public Property Let PicturePosition(New_Position As constPos)
    m_PicturePosition = New_Position
    
    ButPos m_PicturePosition
    
    PropertyChanged "CaptionPosition"
End Property

Function ButPos(ByVal m_PicturePosition)

Select Case m_PicturePosition
    Case 0:
        ButPic.Left = 0
    Case 1:
        ButPic.Left = (UserControl.Width \ 2) - (ButPic.Width \ 2)
    Case 2:
        ButPic.Left = UserControl.Width - ButPic.Width
End Select

ButPic.Top = (UserControl.Height \ 2) - (ButPic.Height \ 2)
Chk_Label.Top = (UserControl.Height \ 2) - (Chk_Label.Height \ 2)
    
End Function


Public Property Get PictureBut() As Picture
    Set PictureBut = mPictureBut
End Property

Public Property Set PictureBut(ByVal New_PictureBut As Picture)
    Set mPictureBut = New_PictureBut
    
    ButPic.Picture = New_PictureBut
    CapPos m_CaptionPosition
        
    PropertyChanged "PictureBut"
End Property


Public Property Get BorderEnabled() As Boolean
    BorderEnabled = senabledCon
End Property

Public Property Let BorderEnabled(ByVal enabledCon As Boolean)
    senabledCon = enabledCon

    BorderCh (senabledCon)
   
    PropertyChanged "BorderEnabled"
End Property

Private Function BorderCh(ByVal enabledCon As Boolean)
    If enabledCon = False Then
        lnu.Visible = False
        lnl.Visible = False
        lnr.Visible = False
        lnd.Visible = False
    End If
    
    If enabledCon = True Then
        lnu.Visible = True
        lnl.Visible = True
        lnr.Visible = True
        lnd.Visible = True
    End If
End Function

Private Function sButClick()
    MoveTim.Enabled = True
    
    sCol1 = &H809188
    sCol2 = &H222E28
    
    lnl.BorderColor = sCol2
    lnu.BorderColor = sCol2
    lnr.BorderColor = sCol1
    lnd.BorderColor = sCol1
    
    Chk_Label.Top = Chk_Label.Top + 15
    Chk_Label.Left = Chk_Label.Left + 15
    
    ButPic.Top = ButPic.Top + 15
    ButPic.Left = ButPic.Left + 15
    
    VarClc = 1
End Function

Private Function sUnClick()
    sCol1 = &H809188
    sCol2 = &H222E28

    lnl.BorderColor = sCol1
    lnu.BorderColor = sCol1
    lnr.BorderColor = sCol2
    lnd.BorderColor = sCol2

    CapPos m_CaptionPosition
    VarClc = 0

    MoveTim.Enabled = False
End Function

